<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.enterprise_delete"
                   @click="handleDelete">删 除
        </el-button>
        <cy-excel-import :flag="2" file-name="企业信息导入模板" @success="onLoad(page)"></cy-excel-import>
      </template>
      <template slot="residentialId" slot-scope="scope">{{scope.row.residentialName}}</template>
      <template slot="mapSelectForm" slot-scope="scope">
        <div>
<!--          <input class="el-input&#45;&#45;small el-input__inner" placeholder="选择地址" @click="mapVisible = true">-->
          <el-button @click="mapVisible = true"> 选择地址</el-button>
          <el-dialog :append-to-body="true" :close-on-click-modal="false" :modal-append-to-body="false" :visible.sync="mapVisible"
                     title="编辑地址" width="80%">
            <editPolygonMap v-if="mapVisible" :editForm.sync="scope.row" :region.sync="scope.row.region" :latitude.sync="scope.row.latitude" :longitude.sync="scope.row.longitude" :visible.sync="mapVisible"></editPolygonMap>
          </el-dialog>
        </div>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/enterprise/enterprise";
  import CyExcelImport from "../../components/excel/cy-excel-import"
  import editPolygonMap from "../../components/residential/editPolygonMap.vue";
  import {mapGetters} from "vuex";
  import {validateTelphone} from "../../util/validator";

  export default {
    components: {
      CyExcelImport,
      editPolygonMap
    },
    data() {
      return {
        form: {},
        query: {},
        mapVisible:false,
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          labelWidth: 120,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "企业名称",
              prop: "enterpriseName",
              rules: [{
                required: true,
                message: "请输入企业名称",
                trigger: "blur"
              }]
            },
            {
              label: "企业类型",
              prop: "enterpriseType",
              rules: [{
                required: true,
                message: "请输入企业类型",
                trigger: "blur"
              }]
            },
            {
              label:'',
              prop:'mapSelect',
              // row: true,
              // span: 20,
              viewDisplay: false,
              formslot: true,
              hide: true,
            },
            {
              label: "经度",
              prop: "longitude",
              hide: true,
              rules: [{
                required: false,
                message: "请输入经度",
                trigger: "blur"
              }]
            },
            {
              label: "纬度",
              prop: "latitude",
              hide: true,
              rules: [{
                required: false,
                message: "请输入纬度",
                trigger: "blur"
              }]
            },
            {
              label: "园区id",
              prop: "agencyId",
              hide: true,
              display: false,
              rules: [{
                required: true,
                message: "请输入园区id",
                trigger: "blur"
              }]
            },
            {
              label: "所属区域",
              prop: "residentialId",
              // slot: true,
              type: "select",
              search: true,
              searchFilterable: true,
              // cascaderItem: ['buildingId'],
              dicUrl: "/api/cyzh-community/residential/list?size=9000",
              dicFormatter:(res)=>{
                return res.data.records;//返回字典的层级结构
              },
              // dicFlag: false,
              filterable: true,
              props: {
                label: "name",
                value: "id"
              },
              rules: [{
                required: true,
                message: "请选择",
                trigger: "blur"
              }]
            },
            {
              label: "详细地址",
              prop: "region",
              overHidden: true,
              rules: [{
                required: true,
                message: "请输入详细地址",
                trigger: "blur"
              }]
            },
            {
              label: "组织机构代码",
              prop: "organizationCode",
              hide: true,
              rules: [{
                required: false,
                message: "请输入组织机构代码",
                trigger: "blur"
              }]
            },
            {
              label: "统一信用代码",
              prop: "creditCode",
              hide: true,
              rules: [{
                required: true,
                message: "请输入统一信用代码",
                trigger: "blur"
              }]
            },
            {
              label: "注册资金",
              prop: "registeredCapital",
              hide: true,
              rules: [{
                required: false,
                message: "请输入注册资金",
                trigger: "blur"
              }]
            },
            {
              label: "注册地址",
              prop: "registeredAddress",
              hide: true,
              rules: [{
                required: false,
                message: "请输入注册地址",
                trigger: "blur"
              }]
            },
            {
              label: "法定代表人",
              prop: "representative",
              rules: [{
                required: true,
                message: "请输入法定代表人",
                trigger: "blur"
              }]
            },
            {
              label: "成立日期",
              prop: "registeredDate",
              type: 'date',
              format:'yyyy-MM-dd',
              valueFormat:'yyyy-MM-dd',
              rules: [{
                required: false,
                message: "请输入成立日期",
                trigger: "blur"
              }]
            },
            {
              label: "办公电话",
              prop: "officeNum",
              rules: [{
                required: false,
                message: "请输入办公电话",
                trigger: "blur"
              },{
                validator: validateTelphone,
                trigger: "blur"
              }]
            },
            {
              label: "营业执照",
              prop: "businessLicense",
              type: "upload",
              width: 150,
              listType: 'picture-img',
              propsHttp: {
                res: "data",
                url: "link"
              },
              tip: '只能生产jpg/png图片，且不超过500kb',
              action: "/api/blade-resource/oss/endpoint/put-file",
              rules: [{
                required: false,
                message: "请输入营业执照",
                trigger: "blur"
              }]
            },
            {
              label: "logo",
              prop: "logo",
              type: "upload",
              width: 150,
              listType: 'picture-img',
              propsHttp: {
                res: "data",
                url: "link"
              },
              tip: '只能生产jpg/png图片，且不超过500kb',
              action: "/api/blade-resource/oss/endpoint/put-file",
              rules: [{
                required: false,
                message: "请输入logo",
                trigger: "blur"
              }]
            },
            {
              label: "企业简介",
              prop: "enterpriseIntroduce",
              hide: true,
              type: 'textarea',
              rules: [{
                required: false,
                message: "请输入企业简介",
                trigger: "blur"
              }]
            },
            {
              label: "机构路径",
              prop: "orgPosition",
              hide: true,
              display: false,
              rules: [{
                required: true,
                message: "请输入机构路径",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.enterprise_add, false),
          viewBtn: this.vaildData(this.permission.enterprise_view, false),
          delBtn: this.vaildData(this.permission.enterprise_delete, false),
          editBtn: this.vaildData(this.permission.enterprise_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
